// elout de kok 2004
//
// source released under the Creative Commons license.
// http://creativecommons.org/licenses/by-nc-sa/1.0/


import java.applet.*;
import java.awt.*;
import java.applet.Applet;
import java.awt.image.*;
import java.net.*;
import java.io.*;

public class got5k05 extends Applet implements Runnable
{	
	Thread animatorThread;
	MemoryImageSource goofImage;
	Dimension offDimension;
	Image offImage;
	Graphics offGraphics;
	Image memimg;

	static int w=600;
	static int h=400;

	public int pix[] = new int[w*h];
	
	int max=9000;

	float p1x[] = new float[max];
	float p1y[] = new float[max];
	float p1sx[] = new float[max];
	float p1sy[] = new float[max];

	int p1r[] = new int[max];
	int p1g[] = new int[max];
	int p1b[] = new int[max];
	int p1l[] = new int[max];
	int p1t[] = new int[max];
	

	int mx,my,ox,oy,moo; 
	
	int palet=4;
	int mr[]=new int[palet];
	int mg[]=new int[palet];
	int mb[]=new int[palet];
	int curcol=0;
	int lv=50;

	int fx=0;
	int maxfx=1;

	public int[][] beziermat = {
	{-1,3,-3,1},
	{3,-6,3,0},
	{-3,3,0,0},
	{1,0,0,0}
	};

	public int [] gx = new int[4];
	public int [] gy = new int[4];
	public int [] cx = new int[4];
	public int [] cy = new int[4];

	int bezbuf=200;
	public int bezx[] = new int[bezbuf];
	public int bezy[] = new int[bezbuf];

	int t;
	float tsx=50.0f;
	float tsy=50.0f;
	int sx1,sy1,sx2,sy2;
	float dxr,dyr;

	public void init() 
	{
		goofImage = new MemoryImageSource(w, h, ColorModel.getRGBdefault(), pix, 0, w);
		goofImage.setAnimated(true);
		memimg = createImage(goofImage);

		for(int i=0; i<w*h; i++)
		{ 
			pix[i] =  ((0xff<<24) | (150<<16) | (150<<8) | 150);
		}
		 
		changecol();
	}	

	public void start() 
	{
		if (animatorThread == null)
		{
			animatorThread = new Thread(this);
			animatorThread.start();
		}
	}	
	public void stop() 
	{
		if (animatorThread != null)
		{
			animatorThread.stop();
			animatorThread = null;
		}		
	}
	public void run()
	{
		Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
		while (Thread.currentThread() == animatorThread)
		{ 
			repaint();
			try { Thread.sleep(10); }
			catch (InterruptedException e) { }
		}
	}
	public void paint(Graphics g)
	{
		update(g);
	}
	public void update(Graphics g)
	{
		Dimension d = size();

		if ( (offGraphics == null) || (d.width != offDimension.width) || (d.height != offDimension.height) )
		{
			offDimension = d;
			offImage = createImage(d.width, d.height);
			offGraphics = offImage.getGraphics();
		}

		
		moo++;
		//drawp(int n)

		for(int i=0; i<max; i++)
		{ 
			//bob[i].d1();			
			drawp(i);
		}

		goofImage.newPixels(0, 0, w, h);
		offGraphics.drawImage(memimg, 0,0, d.width, d.height, this);
		g.drawImage(offImage, 0, 0, this);
	}

	public synchronized boolean mouseMove(Event evt, int x, int y)
	{
		if (ox!=x || oy!=y)
		{
			ox=mx;
			oy=my;
			mx=x;
			my=y;
			moo=0;

			for(int i=0; i<3; i++)
			{
				gx[i] = gx[i+1];
				gy[i] = gy[i+1];
			}
			gx[3] = mx;
			gy[3] = my;
			drawbezier();
			if(Randomize(30)==0)
			{ 
				curcol=Randomize(4);
			}
			if (fx==0)
			{
				lv=Randomize(100)+4;
				tsx=(Randomize(1000)/100.0f) +24.0f;
				tsy=(Randomize(1000)/100.0f) +24.0f;
				sx1=Randomize(100);
				sy1=Randomize(100);
				sx2=Randomize(100);
				sy2=Randomize(100);
				dxr=(Randomize(100)-50)/50.0f;
				dyr=(Randomize(100)-50)/50.0f;
			}



		}
		
		return true;
	}

	public synchronized boolean mouseEnter(Event evt, int x, int y) 
	{
		requestFocus();
		setCursor();
		showStatus("2004 - Elout de Kok - www.xs4all.nl/~elout/");
		return true;
	}

	public synchronized boolean mouseDown(Event evt, int x, int y) 
	{	
		changecol();
		return true;
	}

	public synchronized boolean keyDown(Event event, int key)
	{
		fx++;
		if (fx>maxfx){fx=0;}

		return true;
	}

	public void setCursor()
	{
		Object frame = getParent();
		while (! (frame instanceof Frame))
		frame = ((Component) frame).getParent();
		((Frame) frame).setCursor(Frame.CROSSHAIR_CURSOR);
	}

	private final int Randomize(int range)
	{
		double  rawResult;
		rawResult = Math.random();
		return (int) (rawResult * range);
	}

	public final void changecol()
	{
		mr[0]=Randomize(255);
		mg[0]=Randomize(255);
		mb[0]=Randomize(255);	
		mr[1]=255-mr[0];
		mg[1]=255-mg[0];
		mb[1]=255-mb[0];
		mr[2]=Randomize(255);
		mg[2]=mr[2];
		mb[2]=mr[2];
		mr[3]=255-mr[2];
		mg[3]=255-mg[2];
		mb[3]=255-mb[2];
	}

	public final void drawbezier()
	{
		float t,t2,t3,step;
		int x,y;//, n=150;
		t=0.0f;
		t2=0.0f;
		t3=0.0f;

        for(int i=0; i<4; i++)
		{
            cx[i] =0;
            cy[i] =0;
            for(int j=0; j<4; j++)
			{
              cx[i] += gx[j]*beziermat[i][j];
              cy[i] += gy[j]*beziermat[i][j];
			}
        } 

		step = 1.0f/bezbuf;
		for(int i=0; i<bezbuf; i++)
		{
            t += step;
            t2 = t*t;
            t3 = t*t2;
            x = (int)(cx[0]*t3 + cx[1]*t2 + cx[2]*t + cx[3]);
            y = (int)(cy[0]*t3 + cy[1]*t2 + cy[2]*t + cy[3]);

			if (x>=0 && x<w && y>=0 && y<h)
			{
				bezx[i]=x;
				bezy[i]=y;
			}
        }

	}

	public final void mixpoint(int d[],int x, int y, int r, int g, int b)
	{
		r = ((((d[(y*w)+x] >> 16) & 0xff)*5) +r)/6;
		g = ((((d[(y*w)+x] >>  8) & 0xff)*5) +g)/6;
        b = ((((d[(y*w)+x]) & 0xff)*5) +b)/6;
		d[(y*w)+x] =  ((0xff<<24) | (r<<16) | (g<<8) | b);
	}
	public final void newp(int n)
	{
			t=Randomize(bezbuf);
			p1t[n]=Randomize(bezbuf);
			p1x[n]=bezx[t];
			p1y[n]=bezy[t];
			
			if(mr[curcol]>160 && mg[curcol]>160 && mb[curcol]>160)
			{
				p1r[n]=mr[curcol];
				p1g[n]=mg[curcol];
				p1b[n]=mb[curcol];			
			}
			else
			{
				t=Randomize(3)+1;		
				p1r[n]=mr[curcol]/t;
				p1g[n]=mg[curcol]/t;
				p1b[n]=mb[curcol]/t;
			}
			p1l[n]=Randomize(lv)+4;
			p1sx[n]=(Randomize(sx1)-sx2)/tsx;
			p1sy[n]=(Randomize(sy1)-sy2)/tsy; 

	}
	public final void drawp(int n)
	{
			p1x[n]=p1x[n]+p1sx[n];
			p1y[n]=p1y[n]+p1sy[n];
			p1l[n]--;
			if (p1l[n]<10){p1sx[n]=dxr;p1sy[n]=dyr;}
			if (p1x[n]>=w || p1x[n]<0 || p1y[n]>=h || p1y[n]<0 || p1l[n]<0)
			{
				newp(n);
			}
			if (moo<50 && p1l[n]>0)
			{
				mixpoint(pix, (int)p1x[n], (int)p1y[n], p1r[n], p1g[n], p1b[n]);
			}

	}

}